## gnats 3.104-5

=== gnats/contrib/tkgnats/Makefile ===
#################################################
#################################################
#### Section 1. Manual Configuration section ####
#################################################
#################################################

# WISHPROG can be a full path or just program name.
WISHPROG	= wish

# Set GNATS=network if you _are_ using the GNATS daemon "gnatsd".
# Set GNATS=local   if you're going to access disk files directly.
GNATS		= local

# Set CHECK_CFG=no if GNATS=local but GNATS is not actually installed yet.
CHECK_CFG	= yes

########## TkGnats installation locations

prefix		= /usr/local

########## tkgnats executable location
BINDIR		= $(prefix)/bin
########## tkgnats.1 man directory
MANDIR		= $(prefix)/man
########## TkGnats is installed here
TKGNATSLIB	= $(prefix)/share/tkgnats

########## Existing GNATS installation locations (required if _not_ using GNATS daemon)

########## location of GNATS pr-edit/npr-edit programs
LIBEXECDIR	= $(prefix)/libexec
########## location of GNATS database
GNATS_ROOT	= $(prefix)/share/gnats/gnats-db

################################################################################
### If everything above is correct, then the following should be automatic.  ###
### If you have trouble with the grep/sed stuff, or if GNATS isn't installed ###
### yet, then set the variables below manually.                              ###
### If GNATS=network, the following variables are not used.                  ###
################################################################################

SUBMITTER       = `grep '^SUBMITTER'  $(GNATS_ROOT)/gnats-adm/config | sed -e 's/^SUBMITTER="\([^"]*\)".*$$/\1/g'`
GNATS_ADDR      = `grep '^GNATS_ADDR' $(GNATS_ROOT)/gnats-adm/config | sed -e 's/^GNATS_ADDR="\([^"]*\)".*$$/\1/g'`
GNATS_USER      = `grep '^GNATS_USER' $(GNATS_ROOT)/gnats-adm/config | sed -e 's/^GNATS_USER="\([^"]*\)".*$$/\1/g'`

#SUBMITTER	= YourSubmitterSite
#GNATS_ADDR	= bugs@bugsrus.com
GNATS_USER	= gnats

#########################################################################
#########################################################################
### Section 2. You shouldn't have to change anything below this point ###
#########################################################################
#########################################################################

MAKEPATH	= mkdir -p
SED		= sed

GNATS_ROOT_REPL =set TkGnats(GNATS_ROOT) $(GNATS_ROOT); \#\#GNATS_ROOT\#\#
GNATS_ROOT_SED  =-e "s,^.*\#\#GNATS_ROOT\#\#,$(GNATS_ROOT_REPL),"

SUBMITTER_REPL  =set TkGnats(SUBMITTER) $(SUBMITTER); \#\#SUBMITTER\#\#
SUBMITTER_SED	=-e "s,^.*\#\#SUBMITTER\#\#,$(SUBMITTER_REPL),"

GNATS_ADDR_REPL =set TkGnats(GNATS_ADDR) $(GNATS_ADDR); \#\#GNATS_ADDR\#\#
GNATS_ADDR_SED	=-e "s,^.*\#\#GNATS_ADDR\#\#,$(GNATS_ADDR_REPL),"

GNATS_USER_REPL =set TkGnats(GNATS_USER) $(GNATS_USER); \#\#GNATS_USER\#\#
GNATS_USER_SED	=-e "s,^.*\#\#GNATS_USER\#\#,$(GNATS_USER_REPL),"

LIBEXECDIR_REPL	=set TkGnats(GNATS_LIBEXECDIR) $(LIBEXECDIR); \#\#LIBEXECDIR\#\#
LIBEXECDIR_SED	=-e "s,^.*\#\#LIBEXECDIR\#\#,$(LIBEXECDIR_REPL),"

TKGNATSLIB_REPL =set TkGnats(lib) $(TKGNATSLIB); \#\#TKGNATSLIB\#\#
TKGNATSLIB_SED	=-e "s,^.*\#\#TKGNATSLIB\#\#,$(TKGNATSLIB_REPL),"

WISH_SED        =-e "3s,^exec wish ,exec $(WISHPROG) ,"

T_LIB	= _tlib
T_BIN	= _tbin

tkgnatsbin= \
 $(T_BIN)/tkgnats

xbmfiles= \
 $(T_LIB)/tkeditpr.xbm \
 $(T_LIB)/tkgnats.xbm \
 $(T_LIB)/tkquerypr.xbm \
 $(T_LIB)/tksendpr.xbm

tkgnatslib= \
 $(T_LIB)/tkgnats.config \
 $(T_LIB)/tkeditpr.tcl \
 $(T_LIB)/tkgnats.doc \
 $(T_LIB)/tkpr_library.tcl \
 $(T_LIB)/tkprfolder.tcl \
 $(T_LIB)/tkprfont.tcl \
 $(T_LIB)/tkprhelp.tcl \
 $(T_LIB)/tkprprint.tcl \
 $(T_LIB)/tkprsort.tcl \
 $(T_LIB)/tkquerypr.tcl \
 $(T_LIB)/tksendpr.tcl \
 $(T_LIB)/tkviewpr.tcl \
 $(T_LIB)/VERSION \
 $(xbmfiles)

manfiles= tkgnats.1

all: check_cfg dirs $(tkgnatslib) $(tkgnatsbin)

# WARNING: the tests below involving GNATS_ADDR and SUBMITTER
#          are very sensitive to having quotes (or not) with various
#          bourne/bash shells. Don't mess with them unless they
#          fail. They are the way they are to make it work for
#          /bin/sh on Solaris 2.5 and IRIX64 6.2 and bash on Linux.
#          This is all due to the nested backticks and single and double quotes.

check_cfg:
	@echo " "
	@cat VERSION
	@echo " "
	@if [ ! $(GNATS) = network -a $(CHECK_CFG) = yes ]; then \
	  rm -f /tmp/tkgnats.errors; \
	  echo "Checking the Makefile configuration variables for your GNATS setup..."; \
	  echo "---------------------------------------------------------------------"; \
	  echo " "; \
	  if [ ! -d $(GNATS_ROOT) ]; then \
	    echo "*** Error: GNATS_ROOT=$(GNATS_ROOT) seems to be incorrect."; \
	    touch /tmp/tkgnats.errors; \
	  else \
	    echo \'$(GNATS_ROOT)\' is the configured path for GNATS_ROOT.; \
	  fi; \
	  if [ ! -f $(GNATS_ROOT)/gnats-adm/config ]; then \
	    echo "*** Error: Cannot find GNATS config file $(GNATS_ROOT)/gnats-adm/config."; \
	    touch /tmp/tkgnats.errors; \
	  fi; \
	  if [ ! -d $(LIBEXECDIR)/gnats ]; then \
	    echo "*** Error: Cannot find '$(LIBEXECDIR)/gnats'."; \
	    touch /tmp/tkgnats.errors; \
	  else \
	    echo \'$(LIBEXECDIR)\' is the configured path for GNATS LIBEXECDIR.; \
	  fi; \
	  if [ x$(SUBMITTER) = "x" ]; then \
	    echo "*** Error: SUBMITTER is not set in $(GNATS_ROOT)/gnats-adm/config."; \
	    echo "    Set SUBMITTER in this file to the name of your site. "; \
	    echo "    GNATS and TkGnats use it as your Submitter-Id."; \
	    touch /tmp/tkgnats.errors; \
	  else \
	    echo \'$(SUBMITTER)\' is the configured name for SUBMITTER.; \
	  fi; \
	  if [ x$(GNATS_ADDR) = "x" ]; then \
	    echo "*** Error: GNATS_ADDR is not set in $(GNATS_ROOT)/gnats-adm/config."; \
	    echo "    Set GNATS_ADDR in this file to the email address that gnats"; \
	    echo "    bugs are supposed to be sent to. It's probably missing due to"; \
	    echo "    an old bug in the GNATS installation Makefile."; \
	    touch /tmp/tkgnats.errors; \
	  else \
	    echo \'$(GNATS_ADDR)\' is the configured mail address for GNATS_ADDR.; \
	  fi; \
	  if [ x$(GNATS_USER) = "x" ]; then \
	    echo "*** Error: GNATS_USER is not set in $(GNATS_ROOT)/gnats-adm/config."; \
	    echo "    Set GNATS_USER in this file to the gnats administrator user id."; \
	    touch /tmp/tkgnats.errors; \
	  else \
	    echo \'$(GNATS_USER)\' is the configured user id for GNATS_USER.; \
	  fi; \
	  if [ -f /tmp/tkgnats.errors ]; then \
	    echo "*** Errors have been detected. Make aborted."; \
	    echo "*** If you don't have GNATS installed locally, run make with CHECK_CFG=no."; \
	    rm -f /tmp/tkgnats.errors; \
	    exit 1; \
	  fi; \
	  echo " "; \
	  echo "Done checking GNATS configuration."; \
	  echo "----------------------------------"; \
	  echo " "; \
	elif [ ! $(GNATS) = network ]; then \
	  echo "By-passed checking GNATS configuration."; \
	  echo "---------------------------------------"; \
	  echo " "; \
	  echo \'$(GNATS_ROOT)\' is the configured path for GNATS_ROOT.; \
	  echo \'$(LIBEXECDIR)\' is the configured path for GNATS LIBEXECDIR.; \
	  echo \'$(SUBMITTER)\' is the configured name for SUBMITTER.; \
	  echo \'$(GNATS_ADDR)\' is the configured mail address for GNATS_ADDR.; \
	  echo \'$(GNATS_USER)\' is the configured user id for GNATS_USER.; \
	  echo " "; \
	fi

uninstall: uninstall_tkgnatsbin uninstall_tkgnatslib uninstall_man

uninstall_tkgnatsbin:
	for f in $(tkgnatsbin); do \
	    rm -if "$(BINDIR)/`basename $$f`"; \
	done

uninstall_tkgnatslib:
	for f in $(tkgnatslib); do \
	    rm -if "$(TKGNATSLIB)/`basename $$f`"; \
	done

uninstall_man:
	for f in $(manfiles); do \
	    rm -if $(MANDIR)/man1/$$f; \
	done

clean:
	rm -rf $(T_LIB) $(T_BIN) *~

dirs:
	@-$(MAKEPATH) $(T_LIB)
	@-$(MAKEPATH) $(T_BIN)

install: all install_tkgnatsbin install_tkgnatslib

install_tkgnatsbin:
	-$(MAKEPATH) $(BINDIR)
	cp -p $(T_BIN)/* $(BINDIR)/

install_tkgnatslib:
	-$(MAKEPATH) $(TKGNATSLIB)
	cp -p $(T_LIB)/* $(TKGNATSLIB)/
	-$(MAKEPATH) $(TKGNATSLIB)/print
	-$(MAKEPATH) $(TKGNATSLIB)/query
	-$(MAKEPATH) $(TKGNATSLIB)/sort
	cp -p print/* $(TKGNATSLIB)/print/
	cp -p query/* $(TKGNATSLIB)/query/
	cp -p sort/*  $(TKGNATSLIB)/sort/

install_man:
	-$(MAKEPATH) $(MANDIR)
	-$(MAKEPATH) $(MANDIR)/man1
	@chmod 664 $(manfiles)
	for f in $(manfiles); do \
	    cp -p $$f $(MANDIR)/man1/$$f; \
	done

$(T_BIN)/tkgnats: tkgnats Makefile
	$(SED) $(WISH_SED) $(TKGNATSLIB_SED) <tkgnats >$@
	@chmod 775 $@

$(T_LIB)/VERSION: VERSION
	cp VERSION $@
	@chmod 664 $@

$(T_LIB)/tkeditpr.tcl: tkeditpr.tcl Makefile
	cp tkeditpr.tcl $@
	@chmod 664 $@

$(T_LIB)/tkviewpr.tcl: tkviewpr.tcl Makefile
	cp tkviewpr.tcl $@
	@chmod 664 $@

$(T_LIB)/tksendpr.tcl: tksendpr.tcl Makefile
	cp tksendpr.tcl $@
	@chmod 664 $@

$(T_LIB)/tkquerypr.tcl: tkquerypr.tcl Makefile
	cp tkquerypr.tcl $@
	@chmod 664 $@

$(T_LIB)/tkprfolder.tcl: tkprfolder.tcl Makefile
	cp tkprfolder.tcl $@
	@chmod 664 $@

$(T_LIB)/tkprfont.tcl: tkprfont.tcl Makefile
	cp tkprfont.tcl $@
	@chmod 664 $@

$(T_LIB)/tkpr_library.tcl: tkpr_library.tcl Makefile
	cp tkpr_library.tcl $@
	@chmod 664 $@

$(T_LIB)/tkprprint.tcl: tkprprint.tcl Makefile
	cp tkprprint.tcl $@
	@chmod 664 $@

$(T_LIB)/tkprsort.tcl: tkprsort.tcl Makefile
	cp tkprsort.tcl $@
	@chmod 664 $@

$(T_LIB)/tkprhelp.tcl: tkprhelp.tcl Makefile
	cp tkprhelp.tcl $@
	@chmod 664 $@

$(T_LIB)/tkgnats.doc: tkgnats.doc Makefile
	cp tkgnats.doc $@
	@chmod 664 $@

# Again, the following ugliness is intentional and works on Linux, Solaris 2.5 and IRIX64 6.2.

$(T_LIB)/tkgnats.config: tkgnats.config Makefile
	@if [ ! $(GNATS) = network ]; then \
	  tempsubm=$(SUBMITTER); \
	  tempsubmrepl="set TkGnats(SUBMITTER) $$tempsubm; \#\#SUBMITTER\#\#"; \
	  tempsubmsed='s,^.*\#\#SUBMITTER\#\#,'$$tempsubmrepl,; \
	  tempaddr=$(GNATS_ADDR); \
	  tempaddrrepl="set TkGnats(GNATS_ADDR) $$tempaddr; \#\#GNATS_ADDR\#\#"; \
	  tempaddrsed='s,^.*\#\#GNATS_ADDR\#\#,'$$tempaddrrepl,; \
	  tempuser=$(GNATS_USER); \
	  tempuserrepl="set TkGnats(GNATS_USER) $$tempuser; \#\#GNATS_USER\#\#"; \
	  tempusersed='s,^.*\#\#GNATS_USER\#\#,'$$tempuserrepl,; \
	  $(SED) $(LIBEXECDIR_SED) \
	      $(GNATS_ROOT_SED) \
	      -e "$$tempsubmsed" \
	      -e "$$tempaddrsed" \
	      -e "$$tempusersed" \
	     <tkgnats.config >$@; \
	  echo $(SED) $(LIBEXECDIR_SED) \
	      $(GNATS_ROOT_SED) \
	      -e "$$tempsubmsed" \
	      -e "$$tempaddrsed" \
	      -e "$$tempusersed" \
	     \<tkgnats.config \>$@; \
	else \
	  echo cp tkgnats.config $@; \
	  cp tkgnats.config $@; \
	fi;
	@chmod 664 $@

# The following was OK on my Linux system but failed on Solaris and IRIX64.

#$(T_LIB)/tkgnats.config: tkgnats.config Makefile
#	$(SED) $(LIBEXECDIR_SED) \
#	    $(GNATS_ROOT_SED) \
#	    $(SUBMITTER_SED) \
#	    $(GNATS_ADDR_SED) \
#	    $(GNATS_USER_SED) \
#	   <tkgnats.config >$@

$(T_LIB)/tkgnats.xbm: tkgnats.xbm Makefile
	cp tkgnats.xbm $@
	@chmod 664 $@

$(T_LIB)/tkquerypr.xbm: tkquerypr.xbm Makefile
	cp tkquerypr.xbm $@
	@chmod 664 $@

$(T_LIB)/tksendpr.xbm: tksendpr.xbm Makefile
	cp tksendpr.xbm $@
	@chmod 664 $@

$(T_LIB)/tkeditpr.xbm: tkeditpr.xbm Makefile
	cp tkeditpr.xbm $@
	@chmod 664 $@

package: clean
	rm -f VERSION
	echo "This is version `pwd | sed -e "s:.*/::g"` and was made by $$LOGNAME@`hostname` on" > VERSION
	date >> VERSION
	echo untarit > /tmp/tkgnpkg.exclude
	dir=`pwd | sed -e "s:.*/::g"`; \
	fil=$$dir.tar.gz; \
	rm -f $$fil; \
	rm -rf _tbin _tlib $$dir.zip; \
	cd ..; \
	tar -cvf - -X /tmp/tkgnpkg.exclude $$dir | gzip -9c > $$fil; \
	rm -rf /tmp/tkgnpkg.exclude; \
	mv $$fil $$dir; \
	cd $$dir; \
	zip -rl9 $$dir.zip * -x *.gz untarit \
	ls  -l $$fil

sed_check:
	(cd $(T_BIN); fgrep usr *) >/tmp/cfg_check.bin
	(cd $(T_LIB); fgrep usr *) >/tmp/cfg_check.lib
	more /tmp/cfg_check.bin /tmp/cfg_check.lib

#
# do not use these rules !!! these are for tkgnats development only !!
#
__all:
	make 'SUBMITTER=calgary' 'GNATS_ADDR=bugs' all
__check:

=== debian/changelog ===
gnats (3.104-5) frozen unstable; urgency=low

  * Include /usr/lib/gnats in path instead of GNATS_ROOT/gnats-bin (Bug#21636)
  * Now depend on 'wish' instead of tk42 (Bug#21490)
  * Move tkgnats man page from /usr/share to /usr (Bug#21029)
  * Corrected gnats user setting (Bug#21030)

 -- Brian White <bcwhite@pobox.com>  Mon, 11 May 1998 19:42:06 -0400

gnats (3.104-4) frozen unstable; urgency=low

  * Fixed GNATS_ROOT problem with contributed scripts (Bug#19554, #19555, #19899)
  * Changed check-categories to abort in case of error (Bug#19898)
  * Fixed tkgnats search path to /usr/share/tkgnats (Bug#19968)
  * Fixed incorrect install of copyright file (Bug#20377)

 -- Brian White <bcwhite@pobox.com>  Sat, 11 Apr 1998 14:11:02 -0400

gnats (3.104-3) unstable; urgency=low

  * Fixed (hopefully) problem with delete-pr (Bug#18832)
  * Fixed spelling mistake in description (Bug#18915)
  * Fixed copyright files in gnats-tk (Bug#19317)
  * Added missing manpages (Bug#19317)

 -- Brian White <bcwhite@pobox.com>  Wed, 11 Mar 1998 13:25:17 -0500

gnats (3.104-2) unstable; urgency=low

  * Fixed problem link to uncompressed.7 (Bug#16163)
  * Fixed incorrect variable in check-db (Bug#16369)

 -- Brian White <bcwhite@pobox.com>  Thu, 19 Feb 1998 13:08:41 -0500

gnats (3.104-1) unstable; urgency=low

  * New upstream source
  * Have postinst call "adduser" if user password entry doesn't exist (Bug#8446)
  * Fixed problem with unset GNATS_ADDR (Bug#11348)

 -- Brian White <bcwhite@pobox.com>  Wed, 23 Jul 1997 14:01:51 -0400

gnats (3.101-2) frozen unstable; urgency=low

  * Added patch to fix problems calling new "at" (Bug#8801)
  * Added patch to fix nis dependancy (Bug#8799)
  * Changed debian/rules to determine PWD itself (Bug#8800)

 -- Brian White <bcwhite@pobox.com>  Fri, 25 Apr 1997 13:27:20 -0400

gnats (3.101-1) unstable; urgency=low

  * New upstream source
  * New packaging format
  * Changed gnats uid/gid to #41
  * Fixed permisions of gnats.conffiles (Bug#4661)
  * Fixed install of send-pr info file (Bug#3053)

 -- Brian White <bcwhite@pobox.com>  Mon, 27 Jan 1997 21:23:55 -0500

gnats (3.2-1) unstable; urgency=low

  * Added Debian GNU/Linux package maintenance system files
  * Fixes required a couple C prototypes
  * and a mod to the Makefile (.in) to properly find the install.sh program

 -- Brian White <bcwhite@pobox.com>  Mon, 18 Nov 1995 23:44:17 -0500


Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: gnats
Section: devel
Priority: optional
Maintainer: Brian White <bcwhite@pobox.com>
Standards-Version: 2.1.3.2

Package: gnats
Architecture: any
Depends: mail-transport-agent, ${shlibs:Depends}
Conflicts: gnats-user
Suggests: emacs
Description: The GNU problem report management system (central database)
 GNATS is a bug-tracking tool designed for use at a central "Support
 Site".  Users who experience problems use electronic mail to
 communicate these problems to "maintainers" at that Support Site.
 .
 GNATS offers many of the same features offered by more generalized
 databases, including editing, querying, and basic reporting.  You can
 access the submitting, editing, and querying functions of GNATS
 through provided utilities or from within GNU Emacs.
 .
 The "gnats" package has the full installation for the central database
 server.  For client systems, use the "gnats-user" package which has just
 the user tools.

Package: gnats-user
Architecture: any
Depends: mail-transport-agent, ${shlibs:Depends}
Conflicts: gnats
Suggests: emacs
Description: The GNU problem report management system (client tools)
 GNATS is a bug-tracking tool designed for use at a central "Support
 Site".  Users who experience problems use electronic mail to
 communicate these problems to "maintainers" at that Support Site.
 .
 GNATS offers many of the same features offered by more generalized
 databases, including editing, querying, and basic reporting.  You can
 access the submitting, editing, and querying functions of GNATS
 through provided utilities or from within GNU Emacs.
 .
 The "gnats-user" package has just the user tools for client machines.
 For the full installation and the central database server use the
 "gnats" package.
 .
 If you prefer not to use either an nfs-mounted database or the client/server
 model, it is possible to make a distribution that works entirely over e-mail.
 For more information, see gnats-info and type 'g' (for goto) followed by
 'mkdist'.  This package is not necessary for email-only setups.

Package: gnats-tk
Architecture: all
Depends: gnats | gnats-user, wish
Description: Tk interface to the GNU problem report management system
 Gnats-Tk is a set of Tk based front ends for the GNATS bug management
 system.

=== debian/rules ===
#! /usr/bin/make -f
#
# Debian build rules for "Gnats" by Brian White <bcwhite@pobox.com>



package	:= gnats
version	:= 3.101-beta

DATADIR := /var/lib
DBDIR   := $(DATADIR)/gnats/gnats-db
GSITE	:= unknown-site
GADDR	:= unknown-addr
GORG	:= unknown-org
MAKEDEFS:= DEFAULT_SITE=$(GSITE) GNATS_SITE=$(GSITE) GNATS_ADDR=$(GADDR) \
	   DEFAULT_ORGANIZATION=$(GORG) SUBMITTER=$(GORG)
GTKDEFS	:= CHECK_CFG=no
CFLAGS	:= -O2 -fomit-frame-pointer
CONFLAGS:= --prefix=/usr --libexecdir='$${prefix}/lib' --with-gnats-root=$(DBDIR) --with-gnats-service=gnats
PWD	:= $(shell pwd)



default:
	@echo "What to do?"
	@echo " - build-server, build-user, binary, binary-server, binary-user,"
	@echo " - clean, distclean"
	@echo " "



build:
	@echo "There is no general 'build' rule."
	@echo "(appropriate builds will be done as required by the binaries)"



build-server:
	$(checkdir)
	rm -f stamp-build-user
	cd gnats; ln -sf contrib/check-db.sh check-db.sh
	cd gnats; ln -sf contrib/delete-pr/delete-pr.sh delete-pr.sh
#	./configure --prefix=/var --exec-prefix=/usr --srcdir=$(PWD) --with-full-gnats
	cd gnats;   ./configure $(CONFLAGS) --with-full-gnats
	cd send-pr; ./configure $(CONFLAGS) --with-full-gnats
	$(MAKE) -C gnats   all info CFLAGS="$(CFLAGS)" LIBIBERTY="" datadir=$(DATADIR) $(MAKEDEFS)
	$(MAKE) -C send-pr all info CFLAGS="$(CFLAGS)" LIBIBERTY="" datadir=$(DATADIR) $(MAKEDEFS)
	touch stamp-build


build-user:
	$(checkdir)
	rm -f stamp-build
	cd gnats;   ./configure $(CONFLAGS)
	cd send-pr; ./configure $(CONFLAGS)
	$(MAKE) -C gnats   all info CFLAGS="$(CFLAGS)" LIBIBERTY="" datadir=$(DATADIR) $(MAKEDEFS)
	$(MAKE) -C send-pr all info CFLAGS="$(CFLAGS)" LIBIBERTY="" datadir=$(DATADIR) $(MAKEDEFS)
	touch stamp-build-user


build-www:
	$(checkdir)
	cd gnats/contrib/wwwgnats; if [ -x wwwgnats.shar ]; then ./wwwgnats.shar; fi
	touch stamp-build-wwwgnats


build-tk:
	$(checkdir)
	$(MAKE) -C gnats/contrib/tkgnats LDIR=/usr SHRDIR=$(DATADIR) $(MAKEDEFS) $(GTKDEFS) clean
	$(MAKE) -C gnats/contrib/tkgnats LDIR=/usr SHRDIR=$(DATADIR) $(MAKEDEFS) $(GTKDEFS) prefix=/usr
	touch stamp-build-tkgnats



gnatsclean:
	$(checkdir)
	-rm -f stamp-*
	-$(MAKE) -C gnats   -i distclean
	-$(MAKE) -C send-pr -i distclean
	-$(MAKE) -C gnats/contrib/tkgnats clean
	-$(MAKE) distclean
	cd gnats; rm -f check-db.sh delete-pr.sh
	cd gnats; rm -f config.c



clean: gnatsclean
	cd gnats/contrib/wwwgnats; \
	if [ -e wwwgnats.shar ]; then \
		find . ! -name wwwgnats.shar ! -name "." ! -name ".." -print | xargs rm -rf; \
	fi;
	-rm -f build build-user build-tk build-www
	-rm -rf debian/tmp debian/substvars debian/files
	find . \( -name  "*~" -o -name  "#*" -o -name  "*.orig" -o -name  "*.rej" \) -print | xargs rm -f
	find . \( -name ".*~" -o -name ".#*" -o -name ".*.orig" -o -name ".*.rej" \) -print | xargs rm -f



binary-server:
	test -f stamp-build || $(MAKE) -f debian/rules gnatsclean build-server
	-rm -rf debian/tmp
	#
	mkdir -p debian/tmp debian/tmp/DEBIAN
	mkdir -p debian/tmp/usr/info debian/tmp/usr/doc/$(package)
	mkdir -p debian/tmp/etc/emacs/site-start.d
#	mkdir -p debian/tmp/etc/cron.daily debian/tmp/etc/cron.weekly
	mkdir -p debian/tmp/usr/bin debian/tmp/usr/lib/gnats debian/tmp/usr/lib/emacs/site-lisp
	mkdir -p debian/tmp/usr/man/man1 debian/tmp/usr/man/man8
	mkdir -p debian/tmp/var/lib/gnats/dist
	#
	$(MAKE) -C gnats   CFLAGS="$(CFLAGS)" prefix=$(PWD)/debian/tmp/usr install install-info \
		datadir=$(PWD)/debian/tmp$(DATADIR) GNATS_ROOT=$(PWD)/debian/tmp$(DBDIR)
	$(MAKE) -C send-pr CFLAGS="$(CFLAGS)" prefix=$(PWD)/debian/tmp/usr install install-info \
		datadir=$(PWD)/debian/tmp$(DATADIR) GNATS_ROOT=$(PWD)/debian/tmp$(DBDIR)
	#
	for i in gnats/contrib/scripts/*-*; do							\
		j=`basename $$i`;								\
		sed $$i >debian/tmp/usr/lib/gnats/$$j						\
			-e 's|GNATS_ROOT=.*|GNATS_ROOT=$(DBDIR)|'				\
			-e 's|/usr/local|/usr|g'						\
			-e 's|^#!/bin/ksh|#!/usr/bin/ksh|';					\
		chmod 755 debian/tmp/usr/lib/gnats/$$j;						\
		(cd debian/tmp/usr/man/man8; ln -sf ../man7/undocumented.7.gz $$j.8.gz); 	\
	done
	cd debian/tmp/usr/man/man8; ln -sf ../man7/undocumented.7.gz delete-pr.8.gz
	cd debian/tmp/usr/man/man8; ln -sf ../man7/undocumented.7.gz check-db.8.gz
	cat debian/README.contrib-scripts gnats/contrib/scripts/README \
		> debian/tmp/usr/doc/$(package)/README.contrib-scripts
	#
	cd debian/tmp/usr/man; gzip -9fv `find . -type f ! -name "*.gz" -print`
	cd debian/tmp/usr/info; gzip -9fv *
	cd debian/tmp$(DATADIR)/gnats/dist; gzip -9v *
	#
	for i in debian/tmp/usr/bin/*; do							\
		j=`basename $$i`;								\
		if head -1 $$i | egrep -q '^#!'; then						\
			cp $$i /tmp/$$j;							\
			sed -e 's|$$GNATS_ROOT/gnats-bin|/usr/lib/gnats|g'			\
			/tmp/$$j > $$i;								\
		fi;										\
		if [ ! -f debian/tmp/usr/man/man1/$$j.1.gz -a					\
		     ! -f debian/tmp/usr/man/man8/$$j.8.gz ]; then				\
			(cd debian/tmp/usr/man/man8; ln -sf ../man7/undocumented.7.gz $$j.8.gz);\
		fi;										\
	done
	#
	cp debian/gnats.el debian/tmp/etc/emacs/site-start.d/50gnats.el
	#
	cp gnats/ChangeLog debian/tmp/usr/doc/$(package)/changelog
	cp debian/changelog debian/tmp/usr/doc/$(package)/changelog.Debian
	cp debian/copyright debian/tmp/usr/doc/$(package)
	cd debian/tmp/usr/doc/$(package); gzip -9v `find . -type f ! -name "*.gz" -print`
#	cd debian/tmp/usr/doc/$(package); ln -sf ../copyright/GPL copyright
	cp debian/user/.profile debian/tmp$(DBDIR)
	chown -R gnats.gnats debian/tmp$(DATADIR)/gnats
	#
	cat                      debian/scripts/init       >debian/tmp/DEBIAN/preinst
	sed -e 1d -e "/'init'/d" debian/scripts/fixprobs  >>debian/tmp/DEBIAN/preinst
	sed -e 1d -e "/'init'/d" debian/scripts/waitcr    >>debian/tmp/DEBIAN/preinst
	cat                      debian/scripts/init       >debian/tmp/DEBIAN/postinst
	sed -e 1d -e "/'init'/d" debian/scripts/addinfo   >>debian/tmp/DEBIAN/postinst
	sed -e 1d -e "/'init'/d" debian/scripts/adduser   >>debian/tmp/DEBIAN/postinst
	sed -e 1d -e "/'init'/d" debian/scripts/addcron   >>debian/tmp/DEBIAN/postinst
	sed -e 1d -e "/'init'/d" debian/scripts/addinetd  >>debian/tmp/DEBIAN/postinst
	sed -e 1d -e "/'init'/d" debian/scripts/addmail   >>debian/tmp/DEBIAN/postinst
	sed -e 1d -e "/'init'/d" debian/scripts/addconfig >>debian/tmp/DEBIAN/postinst
	sed -e 1d -e "/'init'/d" debian/scripts/waitcr    >>debian/tmp/DEBIAN/postinst
	cat                      debian/scripts/init       >debian/tmp/DEBIAN/prerm
	sed -e 1d -e "/'init'/d" debian/scripts/rmmail    >>debian/tmp/DEBIAN/prerm
	sed -e 1d -e "/'init'/d" debian/scripts/rmcron    >>debian/tmp/DEBIAN/prerm
	sed -e 1d -e "/'init'/d" debian/scripts/rminfo    >>debian/tmp/DEBIAN/prerm
	sed -e 1d -e "/'init'/d" debian/scripts/waitcr    >>debian/tmp/DEBIAN/prerm
	cat                      debian/scripts/init       >debian/tmp/DEBIAN/postrm
	sed -e 1d -e "/'init'/d" debian/scripts/rmconfig  >>debian/tmp/DEBIAN/postrm
	sed -e 1d -e "/'init'/d" debian/scripts/rminetd   >>debian/tmp/DEBIAN/postrm
	sed -e 1d -e "/'init'/d" debian/scripts/waitcr    >>debian/tmp/DEBIAN/postrm
	chmod 755 debian/tmp/DEBIAN/*
	cp debian/conffiles debian/tmp/DEBIAN/conffiles
	#
	for i in debian/tmp/usr/bin/* debian/tmp/usr/lib/$(package)/*; do \
		if [ -x $$i ]; then \
			if [ `head -1 $$i | egrep -c ^#!` -eq 0 ]; then \
				strip $$i; \
				j="$$j $$i"; \
			fi; \
		fi; \
	done; \
	if [ -z "$$j" ]; then \
		j=/bin/sh; \
	fi; \
	echo dpkg-shlibdeps $$j; \
	dpkg-shlibdeps $$j
#	dpkg-shlibdeps debian/tmp/usr/bin/query-pr debian/tmp/usr/lib/gnats/*
	dpkg-gencontrol -is -ip -pgnats
	chmod -R go=rX debian/tmp
	find debian/tmp$(DATADIR)/gnats -type d -print | xargs chmod g+s
	dpkg --build debian/tmp
	dpkg-name -o -s .. debian/tmp.deb


binary-user:
	test -f stamp-build-user || $(MAKE) -f debian/rules gnatsclean build-user
	-rm -rf debian/tmp
	#
	mkdir -p debian/tmp debian/tmp/DEBIAN
	mkdir -p debian/tmp/usr/info debian/tmp/usr/doc/$(package)
	mkdir -p debian/tmp/etc/emacs/site-start.d
#	mkdir -p debian/tmp/etc/cron.daily debian/tmp/etc/cron.weekly

## gnats 3.999.beta1+cvs20020303-2

=== doc/man/Makefile ===
# Generated automatically from Makefile.in by configure.
# Makefile for GNU GNATS manual pages.
# Copyright (C) 2001, 2002 Milan Zamazal
# Copyright (C) 1993 Free Software Foundation, Inc.
#
# This file is part of GNU GNATS.
#
# GNU GNATS is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# GNU GNATS is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with GNU GNATS; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

srcdir = .

#FIXME
GNATS_ROOT = @GNATS_ROOT@
GNATS_SITE = @GNATS_SITE@

prefix = /usr

exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
datadir = ${prefix}/share

datadir = ${prefix}/share

mandir = /usr/share/man
man1dir = $(mandir)/man1
man2dir = $(mandir)/man2
man3dir = $(mandir)/man3
man4dir = $(mandir)/man4
man5dir = $(mandir)/man5
man6dir = $(mandir)/man6
man7dir = $(mandir)/man7
man8dir = $(mandir)/man8
man9dir = $(mandir)/man9
man1ext = .1
man5ext = .5
man7ext = .7
man8ext = .8
infodir = ${prefix}/share/info
includedir = ${prefix}/include

SHELL = /bin/sh

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644

#### host, target, and site dependent makefile fragments come in here.
###

SRCS1=	edit-pr$(man1ext) query-pr$(man1ext)
MAN1=	edit-pr.man query-pr.man
SRCS5=  dbconfig$(man5ext) databases$(man5ext)
MAN5=   dbconfig.man databases.man
SRCS7=	gnats$(man7ext)
MAN7=	gnats.man
SRCS8=  mkcat$(man8ext) queue-pr$(man8ext) file-pr$(man8ext) rmcat$(man8ext) gen-index$(man8ext) gnatsd$(man8ext) mkdb$(man8ext) delete-pr$(man8ext) pr-edit$(man8ext)
MAN8 =	mkcat.man queue-pr.man file-pr.man rmcat.man gen-index.man gnatsd.man mkdb.man delete-pr.man pr-edit.man

DISTFILES = Makefile.in $(MAN1) $(MAN7) $(MAN8)

all: all-gnats

all-gnats gnats-man-pages: $(SRCS1) $(SRCS5) $(SRCS7) $(SRCS8)
all-tools tools-man-pages: $(SRCS1)

.PHONY: check
check:

$(SRCS1): ../Makefile $(MAN1)
	$(SHELL) $(srcdir)/../../mkinstalldirs $(man1dir)/
	@echo Creating $@...
	@file=`echo $@ | sed -e 's,\$(man1ext),,'` ; \
	sed -e 's,xGNATS_ROOTx,$(GNATS_ROOT),g' \
	    -e 's,xGNATS_SITEx,$(GNATS_SITE),g' \
	    -e 's,@BINDIR@,$(bindir),g' \
	    -e 's,@PREFIX@,$(prefix),g' \
	    -e 's,@VERSION@,$(VERSION),g' $(srcdir)/$$file.man > tmp-$@
	@mv tmp-$@ $@

$(SRCS5): ../Makefile $(MAN5)
	$(SHELL) $(srcdir)/../../mkinstalldirs $(man5dir)/
	@echo Creating $@...
	@file=`echo $@ | sed -e 's,\$(man5ext),,'` ; \
	sed -e 's,xGNATS_ROOTx,$(GNATS_ROOT),g' \
	    -e 's,xGNATS_SITEx,$(GNATS_SITE),g' \
	    -e 's,@BINDIR@,$(bindir),g' \
	    -e 's,@PREFIX@,$(prefix),g' \
	    -e 's,@VERSION@,$(VERSION),g' $(srcdir)/$$file.man > tmp-$@
	@mv tmp-$@ $@

$(SRCS7): ../Makefile $(MAN7)
	$(SHELL) $(srcdir)/../../mkinstalldirs $(man7dir)/
	@echo Creating $@...
	@file=`echo $@ | sed -e 's,\$(man7ext),,'` ; \
	sed -e 's,xGNATS_ROOTx,$(GNATS_ROOT),g' \
	    -e 's,xGNATS_SITEx,$(GNATS_SITE),g' \
	    -e 's,@DATADIR@,$(datadir),g' \
	    -e 's,@VERSION@,$(VERSION),g' $(srcdir)/$$file.man > tmp-$@
	@mv tmp-$@ $@

$(SRCS8): ../Makefile $(MAN8)
	$(SHELL) $(srcdir)/../../mkinstalldirs $(man8dir)/
	@echo Creating $@...
	@file=`echo $@ | sed -e 's,\$(man8ext),,'` ; \
	sed -e 's,xGNATS_ROOTx,$(GNATS_ROOT),g' \
	    -e 's,xGNATS_SITEx,$(GNATS_SITE),g' \
	    -e 's,@DATADIR@,$(datadir),g' \
	    -e 's,@VERSION@,$(VERSION),g' $(srcdir)/$$file.man > tmp-$@
	@mv tmp-$@ $@

info install-info clean-info:
dvi:
TAGS:

mostlyclean: force
	rm -f $(SRCS1) $(SRCS5) $(SRCS7) $(SRCS8)
clean: mostlyclean
distclean: clean
	rm -f Makefile
realclean: distclean

install: install-gnats install-tools

install-gnats install-gnats-man: all-gnats install-tools
	for i in $(SRCS5); do \
	    $(INSTALL_DATA) $$i $(man5dir)/$$i; \
	done
	for i in $(SRCS7); do \
	    $(INSTALL_DATA) $$i $(man7dir)/$$i; \
	done
	for i in $(SRCS8); do \
	    $(INSTALL_DATA) $$i $(man8dir)/$$i; \
	done

install-tools install-tools-man: all-tools
	for i in $(SRCS1); do \
	    $(INSTALL_DATA) $$i $(man1dir)/$$i; \
	done

uninstall:
	-for i in $(SRCS1); do rm -f $(man1dir)/$$i; done
	-for i in $(SRCS5); do rm -f $(man5dir)/$$i; done
	-for i in $(SRCS7); do rm -f $(man7dir)/$$i; done
	-for i in $(SRCS8); do rm -f $(man8dir)/$$i; done

force:
dist:

# Prevent GNU make v3 from overflowing arg limit on SysV.
.NOEXPORT:
Makefile: $(srcdir)/Makefile.in
	cd .. && $(SHELL) config.status

=== debian/changelog ===
gnats (3.999.beta1+cvs20020303-2) stable-security; urgency=high

  * CAN-2004-0623: Fix format string vulnerability in misc.c
    (Related BTS: #278577) Report and patch by Joey Hess.
  * Added special detection routine for big/little endianess on MIPS since
    the line "byteorder : {big|little} endian" from /proc/cpuinfo was
    removed as of Linux 2.4.20, resulting in the mipsel buildd being
    unable to build this package.

 -- Martin Schulze <joey@infodrom.org>  Thu,  4 Nov 2004 12:15:12 +0100

gnats (3.999.beta1+cvs20020303-1) unstable; urgency=low

  * New CVS snapshot; closes: #133268, #136176.
  * gnats: Uninstall Emacs files in prerm, not postrm.
  * Remove the *.elc directory in emacsen-remove; closes: #132535.
  * exim.conf location updated.

 -- Milan Zamazal <pdm@debian.org>  Sat,  2 Mar 2002 21:59:14 +0100

gnats (3.999.beta1-1) unstable; urgency=low

  * New upstream version (wow!).

 -- Milan Zamazal <pdm@debian.org>  Sat,  5 Jan 2002 22:08:58 +0100

gnats (3.999.20011223-2) unstable; urgency=low

  * Restore gnats-queue if it gets deleted during the upgrade.

 -- Milan Zamazal <pdm@debian.org>  Sun, 23 Dec 2001 21:56:52 +0100

gnats (3.999.20011223-1) unstable; urgency=low

  * New CVS snapshot; closes: #123205.
  * README.Gnatsweb and Gnatsweb related build targets removed.
  * Don't suggest gnats2w, which is almost orphaned now.
  * Add the `gnats -> root' mail alias; closes: #118237.
  * Home directory changed to /var/lib/gnats.
  * Most /etc/passwd issues are handled automatically now.
  * "Unimportant" debconf messages removed.
  * gnats-dbconfig-mode added to the Emacs startup file.
  * Don't install the /var/lib/gnats/gnats-db directory.
  * Create `default' instead of `standard' link in /etc/gnats/db-config.
  * Create the `default' database if needed.
  * Call dh_installdocs in binary-server and binary-user.
  * Call dh_installdeb in binary-user.
  * Use dh_builddeb.
  * Let all the files in /etc/ are conffiles.
  * DH_COMPAT set to 3.
  * No lintian 1.20.17 errors.

 -- Milan Zamazal <pdm@debian.org>  Sun, 23 Dec 2001 20:42:14 +0100

gnats (3.999.20011112-1) unstable; urgency=low

  * New CVS snapshot; closes: #116652.
  * Don't build-depend on emacs.

 -- Milan Zamazal <pdm@debian.org>  Mon, 12 Nov 2001 18:40:54 +0100

gnats (3.999.20010906-1) unstable; urgency=low

  * New CVS snapshot; closes: #111162.
  * One missing sendmail option added; really closes: #111037.
  * sendmail's location changed to /usr/sbin.
  * Don't use the no longer present --with-full-gnats configure option;
    use *-tools targets for gnats-user.

 -- Milan Zamazal <pdm@debian.org>  Thu,  6 Sep 2001 20:34:32 +0200

gnats (3.999.20010904-1) unstable; urgency=low

  * New CVS snapshot.
  * Set sendmail's location unconditionally so that the package doesn't
    build-depend on a mail-transport-agent; closes: #111037.
  * Don't invoke configure for subdirectories, it's no longer needed.

 -- Milan Zamazal <pdm@debian.org>  Tue,  4 Sep 2001 16:51:36 +0200

gnats (3.999.20010829-1) unstable; urgency=low

  * New CVS snapshot; closes: #110068.
  * Standards 3.5.6 (no change).
  * The obsolete code in `rules' using /tmp commented out; closes: #109440.
  * Build on Alpha again (if the porters have got their Alphas running, I
    might find out what's wrong with the compilation there).
  * No lintian 1.20.14 errors.

 -- Milan Zamazal <pdm@debian.org>  Wed, 29 Aug 2001 21:37:12 +0200

gnats (3.999.20010729-1) unstable; urgency=low

  * New CVS snapshot.
  * Use `ln -sf' in installation scripts to rewrite dangling symlinks;
    closes: #99632.
  * Update documentation handling caused by the source tree
    reorganization.
  * Call check-db in cron with `--all-databases'.
  * Site name guessing improved and asks the user now; closes: #78181.
  * Standards 3.5.5.
  * No lintian 1.20.13 errors.
  * Don't build with -Werror on alpha; closes: #99283.
    (I'm very annoyed by doing this, it "fixes" a bug just by ignoring it,
    but I don't have a reliable access to any Alpha machine and I don't
    know a better way how to push the package to testing in a reasonable
    way.)
  * Since the previous "fix" won't work until the top-level GNATS
    configure stuff is reworked, don't build on alpha at all (due to
    deficiences in the Architecture field syntax, this prevents building
    on newly introduced architectures as well).
  * Home page location in description changed.
  * Typo in the item type of a debconf template fixed; closes: #106322.
  * Create `locks' subdirectory in the default database; closes: #104195.

 -- Milan Zamazal <pdm@debian.org>  Sun, 29 Jul 2001 14:14:03 +0200

gnats (3.999.20010617-1) unstable; urgency=low

  * New CVS snapshot; closes: #98833.
  * Add configuration files to the standard database if necessary;
    closes: #99644.
  * The site name configuration code removed.
  
 -- Milan Zamazal <pdm@debian.org>  Sun, 17 Jun 2001 21:06:32 +0200

gnats (3.999.20010527-1) unstable; urgency=low

  * New CVS snapshot.
  * Emacs local variables removed from this file.
  * The DEFAULTSDIR hack removed.
  * Ensure cron jobs exit with the code 0.
  * The Debian files explicitly put in public domain.

 -- Milan Zamazal <pdm@debian.org>  Sun, 27 May 2001 14:21:40 +0200

gnats (3.999.20010225-2) unstable; urgency=low

  * Man page linking moved after dh_compress; closes: #90004, #90007.
  * Lintian override file added.

 -- Milan Zamazal <pdm@debian.org>  Mon, 19 Mar 2001 18:21:57 +0100

gnats (3.999.20010225-1) unstable; urgency=low

  * Priority changed to `extra'.
  * Moved to standards 3.5.0.
  * The `-g' compilation flag made optional, w.r.t. DEB_BUILD_OPTIONS.
  * gnats-user: Links to undocumented man pages removed.
  * Permissions of control files fixed.
  * `exim' prepended to the dependencies on `mail-transport-agent'.
  * Link unavailable man pages to gnats.7.
  * gnatsweb entry removed from `control'; closes: #89044.
  * No lintian 1.20.6 errors.



=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: gnats
 Section: devel
-Priority: optional
-Maintainer: Brian White <bcwhite@pobox.com>
-Standards-Version: 2.1.3.2
+Priority: extra
+Maintainer: Milan Zamazal <pdm@debian.org>
+Build-Depends: debhelper (>> 3.0.0), m4, texinfo, texi2html, bison, flex
+Standards-Version: 3.5.6
 
 Package: gnats
 Architecture: any
-Depends: mail-transport-agent, ${shlibs:Depends}
+Depends: exim | mail-transport-agent, debianutils (>= 1.6), debconf, ${shlibs:Depends}
 Conflicts: gnats-user
-Suggests: emacs
+Suggests: emacsen, gnats-tk, gnatsweb
 Description: The GNU problem report management system (central database)
  GNATS is a bug-tracking tool designed for use at a central "Support
  Site".  Users who experience problems use electronic mail to
@@ -22,12 +23,14 @@
  The "gnats" package has the full installation for the central database
  server.  For client systems, use the "gnats-user" package which has just
  the user tools.
+ .
+ Homepage: http://www.gnu.org/software/gnats
 
 Package: gnats-user
 Architecture: any
-Depends: mail-transport-agent, ${shlibs:Depends}
+Depends: exim | mail-transport-agent, debianutils (>= 1.6), debconf, ${shlibs:Depends}
 Conflicts: gnats
-Suggests: emacs
+Suggests: emacsen, gnatsweb
 Description: The GNU problem report management system (client tools)
  GNATS is a bug-tracking tool designed for use at a central "Support
  Site".  Users who experience problems use electronic mail to
@@ -46,10 +49,5 @@
  model, it is possible to make a distribution that works entirely over e-mail.
  For more information, see gnats-info and type 'g' (for goto) followed by
  'mkdist'.  This package is not necessary for email-only setups.
-
-Package: gnats-tk
-Architecture: all
-Depends: gnats | gnats-user, wish
-Description: Tk interface to the GNU problem report management system
- Gnats-Tk is a set of Tk based front ends for the GNATS bug management
- system.
+ .
+ Homepage: http://www.gnu.org/software/gnats

=== debian/rules ===
#! /usr/bin/make -f
#
# Debian build rules for "Gnats" by Brian White <bcwhite@pobox.com>
# Taken over by Milan Zamazal <pdm@debian.org>

export DH_COMPAT=3

package	:= gnats

DATADIR := /var/lib
HOMEDIR := $(DATADIR)/gnats
DBDIR   := $(DATADIR)/gnats/gnats-db
LISPDIR := /usr/share/emacs/site-lisp/gnats
MANDIR  := /usr/share/man
SYSCONFDIR := /etc
CONFDIR := $(SYSCONFDIR)/$(package)
USER_ACCESS_FILE := $(CONFDIR)/gnatsd.user_access
HOST_ACCESS_FILE := $(CONFDIR)/gnatsd.host_access
DATABASES := $(CONFDIR)/databases
GSITE	:= unknown-site
GADDR	:= unknown-addr
GORG	:= unknown-org
GADMIN  := gnats-admin
GUSER   := gnats
MAKEDEFS:= DEFAULT_SITE=$(GSITE) GNATS_SITE=$(GSITE) GNATS_ADMIN=$(GADMIN) \
	   GNATS_ADDR=$(GADDR) DEFAULT_ORGANIZATION=$(GORG) SUBMITTER=$(GORG) \
	   GNATS_USER=$(GUSER)
GTKDEFS	:= CHECK_CFG=no
CFLAGS := -O2
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -g
endif
CONF_SENDMAIL := SENDMAIL=/usr/sbin/sendmail

# The ugly Alpha build-error hack
ifeq ($(DEB_HOST_ARCH),)
  ARCH:=$(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)
else
  ARCH:=$(DEB_HOST_ARCH)
endif
ifeq ($(ARCH),alpha)
  MAKEDEFS := GCC_CFLAGS='-W -Wall -ansi -pedantic -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Wno-format' $(MAKEDEFS)
endif

CONFLAGS:= --prefix=/usr --libexecdir='$${prefix}/lib' --infodir='$${prefix}/share/info' --mandir=$(MANDIR) --sysconfdir=$(SYSCONFDIR) --with-gnats-root=$(DBDIR) --with-gnats-service=gnats --with-gnats-default-db=/var/lib/gnats/gnats-db --with-gnatsd-user-access-file=$(USER_ACCESS_FILE) --with-gnatsd-host-access-file=$(HOST_ACCESS_FILE) --with-gnats-dblist-file=$(DATABASES)
PWD	:= $(shell pwd)
TKGNATS := tkgnats

default:
	@echo "What to do?"
	@echo " - build-server, build-user, build-tk,"
	@echo " - binary, binary-server, binary-user, binary-tk, "
	@echo " - clean, distclean"
	@echo " "

build:
	@echo "There is no general 'build' rule."
	@echo "(appropriate builds will be done as required by the binaries)"

build-server:
	dh_testdir
	rm -f stamp-build-user
	$(CONF_SENDMAIL) ./configure $(CONFLAGS)
	$(MAKE) all info CFLAGS="$(CFLAGS)" datadir=$(DATADIR) $(MAKEDEFS)
	cd doc && texi2html -split_chapter gnats.texi
	touch stamp-build

build-user:
	dh_testdir
	rm -f stamp-build
	$(CONF_SENDMAIL) ./configure $(CONFLAGS)
	$(MAKE) all-tools info CFLAGS="$(CFLAGS)" datadir=$(DATADIR) \
		$(MAKEDEFS)
	cd doc && texi2html -split_chapter gnats.texi
	touch stamp-build-user

build-tk:
	dh_testdir
	$(MAKE) -C contrib/$(TKGNATS) LDIR=/usr SHRDIR=$(DATADIR) \
		$(MAKEDEFS) $(GTKDEFS) clean
	$(MAKE) -C contrib/$(TKGNATS) LDIR=/usr SHRDIR=$(DATADIR) \
		$(MAKEDEFS) $(GTKDEFS) prefix=/usr LIBEXECDIR=/usr/lib
	touch stamp-build-tkgnats

gnatsclean:
	dh_testdir
	-rm -f stamp-*
	$(CONF_SENDMAIL) ./configure $(CONFLAGS)
	-$(MAKE) -C contrib/$(TKGNATS) clean
	-$(MAKE) distclean
	cd doc && rm -f *.html

clean: gnatsclean
	dh_testdir
	-rm -f build build-user build-tk
	dh_clean

binary-server:
	dh_testdir
	dh_testroot
	test -f stamp-build || $(MAKE) -f debian/rules gnatsclean build-server
	dh_installdirs -p$(package) etc/cron.daily etc/cron.d \
		etc/emacs/site-start.d \
		etc/gnats/db-config usr/bin usr/share/doc/$(package)/html \
		usr/share/info usr/share/lintian/overrides \
		usr/lib/emacsen-common/packages/install \
		usr/lib/emacsen-common/packages/remove \
		usr/lib/gnats usr/share/man/man1 usr/share/man/man5 \
		usr/share/man/man7 usr/share/man/man8
	$(MAKE) -C gnats CFLAGS="$(CFLAGS)" prefix=$(PWD)/debian/gnats/usr \
		install $(MAKEDEFS) \
		datadir=$(PWD)/debian/gnats$(DATADIR) \
		sysconfdir=$(PWD)/debian/gnats$(SYSCONFDIR) \
		lispdir=$(PWD)/debian/gnats$(LISPDIR) \
		mandir=$(PWD)/debian/gnats$(MANDIR) \
		GNATS_ROOT=$(PWD)/debian/gnats$(DBDIR) \
		GNATSD_USER_ACCESS_FILE=$(PWD)/debian/gnats$(USER_ACCESS_FILE)\
		GNATSD_HOST_ACCESS_FILE=$(PWD)/debian/gnats$(HOST_ACCESS_FILE)\
		GLOBAL_DB_LIST_FILE=$(PWD)/debian/gnats$(DATABASES)
	$(MAKE) -C send-pr CFLAGS="$(CFLAGS)" prefix=$(PWD)/debian/gnats/usr \
		install $(MAKEDEFS) \
		datadir=$(PWD)/debian/gnats$(DATADIR) \
		sysconfdir=$(PWD)/debian/gnats$(SYSCONFDIR) \
		lispdir=$(PWD)/debian/gnats$(LISPDIR) \
		mandir=$(PWD)/debian/gnats$(MANDIR) \
		GNATS_ROOT=$(PWD)/debian/gnats$(DBDIR) \
		GNATSD_USER_ACCESS_FILE=$(PWD)/debian/gnats$(USER_ACCESS_FILE)\
		GNATSD_HOST_ACCESS_FILE=$(PWD)/debian/gnats$(HOST_ACCESS_FILE)\
		GLOBAL_DB_LIST_FILE=$(PWD)/debian/gnats$(DATABASES)
	$(MAKE) -C doc CFLAGS="$(CFLAGS)" prefix=$(PWD)/debian/gnats/usr \
		install $(MAKEDEFS) \
		datadir=$(PWD)/debian/gnats$(DATADIR) \
		sysconfdir=$(PWD)/debian/gnats$(SYSCONFDIR) \
		lispdir=$(PWD)/debian/gnats$(LISPDIR) \
		mandir=$(PWD)/debian/gnats$(MANDIR) \
		GNATS_ROOT=$(PWD)/debian/gnats$(DBDIR) \
		GNATSD_USER_ACCESS_FILE=$(PWD)/debian/gnats$(USER_ACCESS_FILE)\
		GNATSD_HOST_ACCESS_FILE=$(PWD)/debian/gnats$(HOST_ACCESS_FILE)\
		GLOBAL_DB_LIST_FILE=$(PWD)/debian/gnats$(DATABASES)
	install -m 644 debian/misc/send-pr.conf debian/gnats$(CONFDIR)/
	cp debian/gnats.el debian/gnats/etc/emacs/site-start.d/50gnats.el
	install -m 644 doc/*.html debian/gnats/usr/share/doc/$(package)/html/
	install -m 644 debian/dhelp \
		debian/gnats/usr/share/doc/$(package)/html/.dhelp
	ln -s gnats_toc.html \
		debian/gnats/usr/share/doc/$(package)/html/index.html
	dh_installchangelogs ChangeLog -p$(package)
	dh_installdocs -p$(package)
	dh_installdebconf -p$(package)
	set -e; for i in install remove; do \
		sed 's/|PACKAGE|/gnats/' debian/emacs.$$i \
		>debian/gnats/usr/lib/emacsen-common/packages/$$i/gnats; \
		chmod 755 \
			debian/gnats/usr/lib/emacsen-common/packages/$$i/gnats;\
	done
	install debian/cron.daily debian/gnats/etc/cron.daily/gnats
	install -m 644 debian/cron.d debian/gnats/etc/cron.d/gnats
	install -m 644 debian/user/profile debian/gnats$(HOMEDIR)/.profile
	chown -R gnats.gnats debian/gnats$(DATADIR)/gnats
	chown -R gnats.gnats debian/gnats$(SYSCONFDIR)
	install -m 644 debian/overrides.$(package) \
		debian/gnats/usr/share/lintian/overrides/$(package)
	dh_compress -p$(package)
#	gzip -9 debian/gnats/var/lib/gnats/dist/*
	set -e; for i in debian/gnats/usr/bin/*; do \
		j=`basename $$i`; \
		if [ ! -f debian/gnats/usr/share/man/man1/$$j.1.gz -a \
		     ! -f debian/gnats/usr/share/man/man8/$$j.8.gz ]; then \
			ln -s ../man7/gnats.7.gz \
			      debian/gnats$(MANDIR)/man8/$$j.8.gz; \
		fi; \
	done
	ln -s ../man7/gnats.7.gz debian/gnats$(MANDIR)/man8/check-db.8.gz
	dh_strip -p$(package)
	dh_installdeb -p$(package)
	sed 's/^PACKAGE=$$/PACKAGE=$(package)/' debian/scripts/init \
		>debian/gnats/DEBIAN/preinst
	set -e; for s in fixprobs; do \
		sed -e 1,3d debian/scripts/$$s >>debian/gnats/DEBIAN/preinst; \
	done
	sed 's/^PACKAGE=$$/PACKAGE=$(package)/' debian/scripts/init \
		>debian/gnats/DEBIAN/postinst
	set -e; for s in addinfo adduser addinetd addmail addconfig \
		addemacs addfhs addhtml upgrade; do \
		sed -e 1,3d debian/scripts/$$s >>debian/gnats/DEBIAN/postinst;\
	done
	sed 's/^PACKAGE=$$/PACKAGE=$(package)/' debian/scripts/init \
		>debian/gnats/DEBIAN/prerm
	set -e; for s in rmconfig rmemacs rmmail rminfo rmfhs; do \
		sed -e 1,3d debian/scripts/$$s >>debian/gnats/DEBIAN/prerm; \
	done
	sed 's/^PACKAGE=$$/PACKAGE=$(package)/' debian/scripts/init \
		>debian/gnats/DEBIAN/postrm
	set -e; for s in rmdebconf rminetd; do \
		sed -e 1,3d debian/scripts/$$s >>debian/gnats/DEBIAN/postrm; \
	done
	chmod 755 debian/gnats/DEBIAN/p*
	dh_shlibdeps -p$(package)
	dh_gencontrol -p$(package)
	chmod 644 debian/gnats$(MANDIR)/man7/gnats.7.gz
	chmod -R u+w,go=rX debian/gnats
	find debian/gnats -name 'gnatsd.*access' | xargs -r chmod 600
	find debian/gnats$(DATADIR)/gnats -type d -print | xargs -r chmod g+s
	dh_md5sums -p$(package)
	dh_builddeb -p$(package)

binary-user:
	dh_testdir
	dh_testroot
	test -f stamp-build-user || $(MAKE) -f debian/rules gnatsclean \
		build-user
	dh_installdirs -p$(package)-user etc/emacs/site-start.d usr/bin \
		usr/lib/emacsen-common/packages/install \
